#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#define INNERLOOP 10000

int main(int argc, char *argv[])
{
	time_t start = time(NULL), next = start + 2;
	long long int cnt = 0;
	struct random_data rd;
	struct drand48_data dd;
	char statebuf[256];

	if (srand48_r(1, &dd) == -1)
		printf("srand48_r failed\n");

	for(;;)
	{
		time_t cur;
		int loop;

		for(loop=0; loop<INNERLOOP; loop++)
		{
			unsigned short xsubi[3];
			unsigned short int seed16v[3];
			unsigned short param[7];
			double dummy2;
			unsigned int dummy3;
			int32_t dummy_int32;
			double dummy_double;
			long int dummy_longint;
			long long int dummy = rand();
			if (dummy < 0 || dummy > RAND_MAX)
				printf("rand() out of range: %lld\n", dummy);

			dummy = random();
			if (dummy < 0 || dummy > RAND_MAX)
				printf("random() out of range: %lld\n", dummy);

			dummy2 = drand48();
			if (dummy2 < 0 || dummy2 >= 1.0)
				printf("drand48() out of range: %f\n", dummy2);

			dummy2 = erand48(xsubi);
			if (dummy2 < 0 || dummy2 >= 1.0)
				printf("erand48() out of range: %f\n", dummy2);

			dummy = lrand48();
			if (dummy < 0 || dummy >= ((long long int)1 << 31))
				printf("lrand48() out of range: %lld\n", dummy);

			dummy = nrand48(xsubi);
			if (dummy < 0 || dummy >= ((long long int)1 << 31))
				printf("nrand48() out of range: %lld\n", dummy);

			dummy = mrand48();
			if (dummy < -((long long int)1 << 31) || dummy >= ((long long int)1 << 31))
				printf("mrand48() out of range: %lld\n", dummy);

			dummy = jrand48(xsubi);
			if (dummy < -((long long int)1 << 31) || dummy >= ((long long int)1 << 31))
				printf("jrand48() out of range: %lld\n", dummy);

			if (srand48_r(1, &dd) == -1)
				printf("srand48_r failed\n");

			if (seed48_r(seed16v, &dd) == -1)
				printf("seed48_r failed\n");

			dummy = rand_r(&dummy3);
			if (dummy < 0 || dummy > RAND_MAX)
				printf("rand_r() out of range: %lld\n", dummy);

			srand(2);

			srandom(2);

			srand48(2);

			lcong48(param);

			if (lcong48_r(param, &dd) == -1)
				printf("lcong48_r failed\n");

			if (random_r(&rd, &dummy_int32) == -1)
				printf("random_r failed\n");

			if (srandom_r(1, &rd) == -1)
				printf("srandom_r failed\n");

			if (initstate(1, statebuf, sizeof(statebuf)) == NULL)
				printf("initstate failed\n");

			if (setstate(statebuf) == NULL)
				printf("setstate failed\n");

			if (initstate_r(1, statebuf, sizeof(statebuf), &rd) == -1)
				printf("initstate_r failed\n");

			if (setstate_r(statebuf, &rd) == -1)
				printf("setstate_r failed\n");

			if (drand48_r(&dd, &dummy_double) == -1)
				printf("drand48_r failed\n");
			if (dummy_double < 0 || dummy_double >= 1.0)
				printf("drand48_r() out of range: %f\n", dummy_double);

			if (erand48_r(xsubi, &dd, &dummy_double) == -1)
				printf("erand48_r failed\n");
			if (dummy_double < 0 || dummy_double >= 1.0)
				printf("erand48_r() out of range: %f\n", dummy_double);

			if (lrand48_r(&dd, &dummy_longint) == -1)
				printf("lrand48_r failed\n");
			if (dummy_longint < 0 || dummy_longint >= ((long long int)1 << 31))
				printf("lrand48_r() out of range: %ld\n", dummy_longint);

			if (nrand48_r(xsubi, &dd, &dummy_longint) == -1)
				printf("nrand48_r failed\n");
			if (dummy_longint < 0 || dummy_longint >= ((long long int)1 << 31))
				printf("nrand48()_r out of range: %ld\n", dummy_longint);

			if (mrand48_r(&dd, &dummy_longint) == -1)
				printf("mrand48_r failed\n");
			if (dummy_longint < -((long long int)1 << 31) || dummy_longint >= ((long long int)1 << 31))
				printf("mrand48_r() out of range: %ld\n", dummy_longint);

			if (jrand48_r(xsubi, &dd, &dummy_longint) == -1)
				printf("jrand48_r failed\n");
			if (dummy_longint < -((long long int)1 << 31) || dummy_longint >= ((long long int)1 << 31))
				printf("jrand48() out of range: %ld\n", dummy_longint);
		}

		cnt += INNERLOOP;

		cur = time(NULL);
		if (cur >= next)
		{
			int tdiff = (cur - start);
			printf("%lld done, %lld per second             \r", cnt, cnt / tdiff);
			fflush(stdout);
			next = cur + 3;
		}
	}

	return 0;
}
